package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AcompanhamentoPUPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaAcompanhamentoPU = By.xpath("//span[text() = 'Acompanhamento de P.U.']");

    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioAcompanhamentoPU = By.xpath("//div[@data-zh-id=\"206540177018058470604870\"]//div[@class=\"list-items show-select\"]//span[text() = 'Acompanhamento de P.U.']");

    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-id=\"206540177042030536084872\"]//div[@class=\"list-items show-select\"]//span[text() = '9999 | DEPOSITO BC 129']");

    By todosServicos = By.xpath("//div[@data-zh-id=\"206540177018388665004881\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");
    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//span[text() = 'Ok']");

    By botaoCampoMes = By.xpath("//div[@id=\"MES\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoMes = By.id("MES");
    By mesNovembro = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Nov']");

    By campoTipoCustoPlanejado = By.id("NMCUSTOPLAN");
    By planejadoCustoMedioLiquidoAtual = By.xpath("//div[@data-zh-id=\"206540177037761313174889\"]//span[text() = 'Custo Médio Líquido Atual']");
    By campoTipoCustoRealizado = By.id("NMCUSTOREAL");
    By realizadoCustoMedioBrutoAtual = By.xpath("//div[@data-zh-id=\"206540177011529051914891\"]//span[text() = 'Custo Médio Bruto Atual']");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"206540177018058470604870\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"206540177042030536084872\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"206540177012531405174877\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMes = By.xpath("//div[@data-zh-id=\"206540177015006359054887\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoCustoPlanejado = By.xpath("//div[@data-zh-id=\"206540177037761313174889\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoCustoRealizado = By.xpath("//div[@data-zh-id=\"206540177011529051914891\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        tempo();
        click(botaoMenu);
        sendKeys(campoPesquisar, "Acompanhamento de P.U.");
        click(telaAcompanhamentoPU);
    }

    public void selecionarRelatorio() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioAcompanhamentoPU);
    }

    public void selecionarUnidade() {
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc129);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoRetiradas);
        click(servicoSolicitacao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void selecionarMesNovembro() {
        clicarCampoSelecionarValor(campoMes, mesNovembro);
    }

    public void selecionarCustos() {
        clicarCampoSelecionarValor(campoTipoCustoPlanejado, planejadoCustoMedioLiquidoAtual);
        clicarCampoSelecionarValor(campoTipoCustoRealizado, realizadoCustoMedioBrutoAtual);
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void campoObrigatorios() {
        click(botaoCampoRelatorio);
        click(botaoCampoUnidade);
        click(todosServicos);
        click(botaoCampoMes);
        click(botaoRelatorio);

        //mensagens encontradas nos campos obrigatórios
        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String mes = getText(mensagemObrigatorioMes);
        String tipoCustoPlanejado = getText(mensagemObrigatorioTipoCustoPlanejado);
        String tipoCustoRealizado = getText(mensagemObrigatorioTipoCustoRealizado);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'relatório'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'serviço'");
        Assert.assertEquals(mes, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'mês'");
        Assert.assertEquals(tipoCustoPlanejado, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'tipo custo planejado'");
        Assert.assertEquals(tipoCustoRealizado, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'tipo custo realizado'");
    }

}
