package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.CalendarioDeCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.openqa.selenium.By;
import org.testng.Assert;
import org.testng.annotations.Test;

public class CalendarioDeCardapioTests extends TestBase {

LoginFlows loginFlows;
CalendarioDeCardapioFlows calendarioDeCardapioFlows;

    public void acessarTelaCalendario() {
    loginFlows = new LoginFlows();
    calendarioDeCardapioFlows = new CalendarioDeCardapioFlows();
    loginFlows.efetuarLogin();
    calendarioDeCardapioFlows.acessarTelaCalendarioCardapio();

    }

    @Test
    public void calendarioDeCardapio(){
        String DTPREVLIBECARD = "31/12/2022";
        String DTLIMAPROVFILI = "02/01/2023";
        String DTLIMAPROVMATR = "05/01/2023";
        String DTCUSCARDAPIO = "01/01/2023";
        String NRDIASPRORROG = "5";

        calendarioDeCardapioFlows = new CalendarioDeCardapioFlows();
        loginFlows = new LoginFlows();
        loginFlows.efetuarLogin();
        calendarioDeCardapioFlows.acessarTelaCalendarioCardapio();
        calendarioDeCardapioFlows.mesCardapioFechado();
        calendarioDeCardapioFlows.validaCamposObrigatorios();
        calendarioDeCardapioFlows.insereCalendarioCardapio();
        calendarioDeCardapioFlows.alteraDataCalendarioCardapio(NRDIASPRORROG);
        calendarioDeCardapioFlows.insereDataMenorAprovacaoMatriz();
        calendarioDeCardapioFlows.insereDataMenorAprovacaoUnidade();
        Assert.assertEquals(DTPREVLIBECARD,calendarioDeCardapioFlows.validaDataLiberacaoCardapio());
        Assert.assertEquals(DTLIMAPROVFILI, calendarioDeCardapioFlows.validaDataAprovacaoUnidade());
        Assert.assertEquals(DTLIMAPROVMATR, calendarioDeCardapioFlows.validaDataAprovacaoMatriz());
        Assert.assertEquals(DTCUSCARDAPIO, calendarioDeCardapioFlows.validaDataCustoCardapio());


    }

    @Test
    public void prorrogacaoAutomatica(){
        String NRDIAS = "5";
        String NRDIASPRORROGACAO = "2";
        acessarTelaCalendario();
        calendarioDeCardapioFlows.prorrogacaoAutomatica();
        Assert.assertEquals(NRDIAS,calendarioDeCardapioFlows.validarDiasProrrogacao());
        calendarioDeCardapioFlows.prorrogacaoUnidadesFiltro(NRDIASPRORROGACAO);

    }

    @Test
    public void exportaCalendario(){
    String DTPREVLIBECARD = "31/12/2022";
    String QTDIAPROFIL = "2";
    String DTLIMAPROVFILI = "02/01/2023";
    String QTDIAPROMAT = "3";
    String DTLIMAPROVMATR = "05/01/2023";
    String QTDIAPRORAPROV = "5";
    String DTBASCONCUSPLAN = "01/01/2023";
    acessarTelaCalendario();
    calendarioDeCardapioFlows.exportarCalendarioCardapio();
    Assert.assertEquals(DTPREVLIBECARD,calendarioDeCardapioFlows.validaPrevisaoLiberacao());
    Assert.assertEquals(QTDIAPROFIL,calendarioDeCardapioFlows.validaDiasAprovacao());
    Assert.assertEquals(DTLIMAPROVFILI,calendarioDeCardapioFlows.validaLimiteAprovacao());
    Assert.assertEquals(QTDIAPROMAT,calendarioDeCardapioFlows.validaDiasAprovacaoMatriz());
    Assert.assertEquals(DTLIMAPROVMATR,calendarioDeCardapioFlows.validaLimiteAprovacaoMatriz());
    Assert.assertEquals(QTDIAPRORAPROV,calendarioDeCardapioFlows.validaDiasProrrogacao());
    Assert.assertEquals(DTBASCONCUSPLAN,calendarioDeCardapioFlows.validaDataCustoBase());
    }

    @Test
    public void logCalendarioCardapio(){
    acessarTelaCalendario();
    calendarioDeCardapioFlows.logCalendarioCardapio();
    }

}
